/* de50d.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__3 = 3;
static integer c__1 = 1;
static integer c__4 = 4;
static integer c__0 = 0;
static integer c__50 = 50;

/* Subroutine */ int de50d_c(integer *nx, doublereal *xn, doublereal *xk,
        doublereal *cn, doublereal *ck, doublereal *f, doublereal *g, 
        doublereal *r__, doublereal *eps, integer *imax, doublereal *y, 
        integer *ik, doublereal *delty, doublereal *rab, integer *ierr)
{
    /* System generated locals */
    integer i__1, i__2;
    doublereal d__1;

    /* Local variables */
    extern /* Subroutine */ int ii10d_c(integer *, integer *, integer *,
            integer *, integer *, integer *, doublereal *),
            as09d_c(integer *, integer *, integer *, integer *, integer *,
            doublereal *, doublereal *);
    static integer j, n;
    static doublereal z__;
    extern /* Subroutine */ int utde11_c(integer *, integer *);
    static integer nphrt, j2, m1, m2, m3;
    static doublereal ca, cb;
    static integer ib, ic, id, ie, na, nc, nb, ne, nf, ng, jj, nh, nl;
    static doublereal za, dx;
    static integer np, np2, np3, np4, np5, np6, np7;

    /* Parameter adjustments */
    --rab;
    --delty;
    --y;
    --r__;
    --g;
    --f;
    --ck;
    --cn;

    /* Function Body */
    *ierr = 0;
    if (*imax >= 0) {
        goto L3;
    } else {
        goto L1;
    }
L1:
    *imax = -(*imax);
    i__1 = *nx;
    for (ie = 1; ie <= i__1; ++ie) {
        y[ie] = 0.;
/* L2: */
    }
    goto L10;
L3:
    if (abs(cn[1]) + abs(cn[2]) <= 0.) {
        goto L4;
    } else {
        goto L5;
    }
L4:
    *ierr = 65;
    goto L23;
L5:
    if (abs(ck[1]) + abs(ck[2]) <= 0.) {
        goto L6;
    } else {
        goto L7;
    }
L6:
    *ierr = 66;
    goto L23;
L7:
    np = *nx;
    np2 = np + np;
    np3 = np2 + np;
    np4 = np3 + np;
    np5 = np4 + np;
    np6 = np5 + np;
    np7 = np6 + np;
    n = np - 1;
    nl = np - 2;
    dx = (*xk - *xn) / (doublereal) n;
/* Computing 2nd power */
    d__1 = dx;
    za = d__1 * d__1 * .5;
    rab[np + 1] = -cn[1] + dx * cn[2] + za * (g[1] * cn[1] - f[1] * cn[2]);
    rab[np2 + 1] = cn[1];
    rab[np3 + 1] = dx * cn[3] + za * (r__[1] * cn[1] - f[1] * cn[3]);
    rab[np] = ck[1];
    rab[np2] = -ck[1] - dx * ck[2] + za * (g[np] * ck[1] - f[np] * ck[2]);
    rab[np4] = -dx * ck[3] + za * (r__[np] * ck[1] - f[np] * ck[3]);
    y[1] = 0.;
    delty[1] = 0.;
    y[np] = 0.;
    delty[np] = 0.;
    i__1 = n;
    for (ib = 2; ib <= i__1; ++ib) {
        y[ib] = 0.;
        delty[ib] = 0.;
        z__ = dx * .5 * f[ib];
        rab[ib] = 1. - z__;
        m1 = np + ib;
        m2 = np2 + ib;
        m3 = np3 + ib;
/* Computing 2nd power */
        d__1 = dx;
        rab[m1] = d__1 * d__1 * g[ib] - 2.;
        rab[m2] = z__ + 1.;
/* Computing 2nd power */
        d__1 = dx;
        rab[m3] = d__1 * d__1 * r__[ib];
/* L8: */
    }
    nphrt = np3 + 1;
    as09d_c(&np, &np, &c__3, &c__1, &c__1, &rab[1], &rab[nphrt]);
    if (*imax <= 0) {
        goto L9;
    } else {
        goto L10;
    }
L9:
    j = 1;
    i__1 = np;
    for (ic = 1; ic <= i__1; ++ic) {
        nc = np3 + ic;
        y[ic] += rab[nc];
/* L3000: */
    }
    *ik = 0;
    goto L24;
L10:
    i__1 = *imax;
    for (j = 1; j <= i__1; ++j) {
/* L11: */
        i__2 = np;
        for (ic = 1; ic <= i__2; ++ic) {
            nc = np3 + ic;
            y[ic] += rab[nc];
            if (j - 1 <= 0) {
                goto L13;
            } else {
                goto L12;
            }
L12:
            delty[ic] += rab[nc];
L13:
            ;
        }
        if (*imax <= 0) {
            goto L14;
        } else {
            goto L15;
        }
L14:
        *ik = 0;
        goto L24;
L15:
        nphrt = np3 + 1;
        ii10d_c(&np, &c__1, &c__1, &np, &c__4, &c__0, &rab[nphrt]);
        rab[np7 + 2] = rab[np7 + 3];
        rab[np6 + 2] = rab[np6 + 3] - rab[np7 + 2];
        na = np7 + n;
        rab[na] = rab[na - 1];
        nb = np6 + n;
        rab[np7] = rab[na] + rab[nb];
        i__2 = n;
        for (j2 = 2; j2 <= i__2; ++j2) {
            if (f[j2] != 0.) {
                goto L17;
            } else {
                goto L16;
            }
L16:
            ca = 0.;
            goto L18;
L17:
            nc = np6 + j2 + 1;
            ca = -(rab[nc - 1] + rab[nc]) / 12.;
L18:
            ne = np7 + j2;
            cb = -rab[ne] / 12.;
            nf = np3 + j2;
            rab[nf] = -(cb + ca * dx * f[j2]);
/* L19: */
        }
        rab[np3 + 1] = cn[1] * (rab[np6 + 2] * 4 + rab[np7 + 2] * 3) / 24.;
        rab[np4] = ck[1] * (rab[na - 1] - rab[np7] * 4) / 24.;
        nphrt = np3 + 1;
        as09d_c(&np, &np, &c__3, &c__1, &c__0, &rab[1], &rab[nphrt]);
        i__2 = np;
        for (id = 1; id <= i__2; ++id) {
            ng = np3 + id;
            if ((d__1 = rab[ng], abs(d__1)) - *eps <= 0.) {
                goto L20;
            } else {
                goto L22;
            }
L20:
            ;
        }
        i__2 = np;
        for (jj = 1; jj <= i__2; ++jj) {
            nh = np3 + jj;
            delty[jj] += rab[nh];
            y[jj] += rab[nh];
/* L21: */
        }
        *ik = j;
        goto L24;
L22:
        ;
    }
    *ierr = 1;
    *ik = -1;
L23:
    utde11_c(ierr, &c__50);
L24:
    return 0;
} /* de50d_c */
